UNIT mTKugel;

interface

uses     mSuM,mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        hatStift : Stift;
        kenntSpielfeld : TSpielfeld;

     //Objektbeziehungen:
        // hatStift : Stift;
        // kenntTSpielfeld : TSpielfeld;

     // Methoden
     private
        procedure loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure zeichne;
        function hPosition : Zahl;
     public
        constructor init (px , py : Zahl);
        procedure bewege;
        procedure merkeSpielfeld(pSpielfeld : TSpielfeld);
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (private) -------------------------------------------
procedure TKugel.loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- zeichne (private) -------------------------------------------
procedure TKugel.zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatStift.hPosition
end;

//-------- init  (public) ----------------------------------------------
constructor TKugel.init (px , py : Zahl);
begin
  hatStift := Stift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  self.zeichne
end;

//-------- bewege (public) ---------------------------------------------
procedure TKugel.bewege;
begin
  self.loesche;
  hatStift.bewegeUm(0.1);       // an die Geschwindigkeit des Rechners anpassen!
  if self.hPosition > kenntSpielfeld.liesRechts -12 then
     self.setzeRichtung(180);  // nach links
  if self.hPosition < kenntSpielfeld.liesLinks + 12 then
     self.setzeRichtung(0);    // nach rechts
  self.Zeichne;
end;

//-------- merkeSpielfeld (public) -------------------------------------
procedure TKugel.merkeSpielfeld(pSpielfeld : TSpielfeld);
begin
   kenntSpielfeld := pSpielfeld
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
