UNIT mTKugel;

interface

uses         mSuM,mTSpielfeld,mTBox;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS

     // Attribute
     private
        hatStift : Stift;
        kenntBox : TBox;
        kenntSpielfeld : TSpielfeld;

     //Objektbeziehungen:
        // hatStift : Stift;
        // kenntTSpielfeld : TSpielfeld;
        // kenntTBox : TBox;

     // Methoden
     private
        procedure loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure zeichne;
     public
        constructor init(px,py,pRichtung:Zahl);
        procedure bewege;
        procedure merkeBox(pBox : TBox);
        procedure merkeSpielfeld(pSpielfeld : TSpielfeld);
        function inBox : Wahrheitswert;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (private) -------------------------------------------
procedure TKugel.loesche;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatStift.dreheBis(pWinkel)
end;

//-------- zeichne (private) -------------------------------------------
procedure TKugel.zeichne;
begin
  hatStift.zeichneKreis(10);
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py,pRichtung:Zahl);
begin
  hatStift := Stift.init;       // Stift erzeugen
  hatStift.bewegeBis(px,py);
  hatStift.dreheBis(pRichtung);
  self.zeichne
end;

//-------- bewege (public) ---------------------------------------------
procedure TKugel.bewege;
   var vx,vy :Zahl;
begin
  self.loesche;
  hatStift.bewegeUm(0.01);       // an die Geschwindigkeit des Rechners anpassen!
  if hatStift.hPosition > kenntSpielfeld.liesRechts -12 then
     hatStift.dreheBis (180-hatStift.winkel);
  if hatStift.hPosition < kenntSpielfeld.liesLinks + 12 then
     hatStift.dreheBis (180-hatStift.winkel);
  if hatStift.vPosition < kenntSpielfeld.liesOben + 12 then
     hatStift.dreheBis (-hatStift.winkel);
  if hatStift.vPosition > kenntSpielfeld.liesUnten - 12 then
     hatStift.dreheBis (-hatStift.winkel);
  self.Zeichne;
end;

//-------- merkeBox (public) -------------------------------------------
procedure TKugel.merkeBox(pBox : TBox);
begin
  kenntBox := pBox
end;

//-------- merkeSpielfeld (public) -------------------------------------
procedure TKugel.merkeSpielfeld(pSpielfeld : TSpielfeld);
begin
   kenntSpielfeld := pSpielfeld  ///test
end;

//-------- inBox (public) ----------------------------------------------
function TKugel.inBox : Wahrheitswert;
begin
   result :=  (kenntBox.liesLinks < self.hatStift.hPosition - 11 ) and
              (kenntBox.liesRechts > self.hatStift.hPosition + 11 ) and
              (kenntBox.liesOben < self.hatStift.vPosition - 11 ) and
              (kenntBox.liesUnten > self.hatStift.vPosition + 11 )
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatStift.gibFrei;             // Stift wieder freigeben
end;

end.
